<script>
import { GlIcon, GlTooltipDirective, GlSprintf } from '@gitlab/ui';
import formattingMixins from 'ee/subscriptions/new/formatting_mixins';
import { formatNumber } from '~/locale';
import PromoPageLink from '~/vue_shared/components/promo_page_link/promo_page_link.vue';
import {
  I18N_SUMMARY_DATES,
  I18N_SUMMARY_QUANTITY,
  I18N_SUMMARY_SUBTOTAL,
  I18N_SUMMARY_TAX,
  I18N_SUMMARY_TAX_NOTE,
  I18N_SUMMARY_TOTAL,
  I18N_STORAGE_TOOLTIP_NOTE,
} from '../../constants';

export default {
  components: {
    PromoPageLink,
    GlSprintf,
    GlIcon,
  },
  directives: {
    GlTooltip: GlTooltipDirective,
  },
  mixins: [formattingMixins],
  props: {
    vat: {
      type: Number,
      required: true,
    },
    totalExVat: {
      type: Number,
      required: true,
    },
    selectedPlanText: {
      type: String,
      required: true,
    },
    selectedPlanPrice: {
      type: Number,
      required: true,
    },
    totalAmount: {
      type: Number,
      required: true,
    },
    quantity: {
      type: Number,
      required: true,
    },
    taxRate: {
      type: Number,
      required: false,
      default: null,
    },
    subscriptionEndDate: {
      type: String,
      required: false,
      default: '',
    },
    hasExpiration: {
      type: Boolean,
      required: false,
      default: false,
    },
  },
  data() {
    return {
      startDate: new Date(),
    };
  },
  computed: {
    endDate() {
      return (
        this.subscriptionEndDate ||
        new Date(this.startDate).setFullYear(this.startDate.getFullYear() + 1)
      );
    },
    hasPositiveQuantity() {
      return this.quantity > 0;
    },
    taxAmount() {
      return this.taxRate ? this.formatAmount(this.vat, this.quantity > 0) : '–';
    },
    taxLine() {
      return `${this.$options.i18n.tax} ${this.$options.i18n.taxNote}`;
    },
    formattedPrice() {
      return formatNumber(this.selectedPlanPrice);
    },
    renderedAmount() {
      return this.totalExVat ? this.formatAmount(this.totalExVat, this.hasPositiveQuantity) : '-';
    },
  },
  i18n: {
    quantity: I18N_SUMMARY_QUANTITY,
    dates: I18N_SUMMARY_DATES,
    subtotal: I18N_SUMMARY_SUBTOTAL,
    tax: I18N_SUMMARY_TAX,
    taxNote: I18N_SUMMARY_TAX_NOTE,
    total: I18N_SUMMARY_TOTAL,
    tooltipNote: I18N_STORAGE_TOOLTIP_NOTE,
  },
  vatHelpPath: `/handbook/tax/#indirect-taxes-management`,
};
</script>
<template>
  <div>
    <div class="gl-mb-3 gl-flex gl-justify-between gl-font-bold">
      <div data-testid="selected-plan">
        {{ selectedPlanText }}
        <span v-if="hasPositiveQuantity" data-testid="quantity">{{
          sprintf($options.i18n.quantity, { quantity })
        }}</span>
      </div>
      <div>
        {{ renderedAmount }}
      </div>
    </div>
    <div class="gl-mb-5 gl-border-b-1 gl-border-b-gray-100 gl-pb-5 gl-border-b-solid">
      <div class="gl-text-subtle" data-testid="price-per-unit">
        <slot name="price-per-unit" :price="formattedPrice"></slot>
      </div>
      <div v-if="hasExpiration" class="gl-text-subtle" data-testid="subscription-period">
        {{
          sprintf($options.i18n.dates, {
            startDate: formatDate(startDate),
            endDate: formatDate(endDate),
          })
        }}
        <gl-icon
          v-if="subscriptionEndDate"
          v-gl-tooltip.right
          :title="$options.i18n.tooltipNote"
          :aria-label="$options.i18n.tooltipNote"
          role="tooltip"
          name="question-o"
        />
      </div>
    </div>
    <div class="gl-mb-5 gl-border-b-1 gl-border-b-gray-100 gl-pb-5 gl-border-b-solid">
      <div class="gl-mb-2 gl-flex gl-justify-between gl-text-subtle">
        <div>{{ $options.i18n.subtotal }}</div>
        <div data-testid="total-ex-vat">
          {{ renderedAmount }}
        </div>
      </div>
      <div class="gl-flex gl-justify-between gl-text-subtle">
        <div data-testid="vat-info-line">
          <gl-sprintf :message="taxLine">
            <template #link="{ content }">
              <promo-page-link
                class="gl-text-subtle gl-underline"
                :path="$options.vatHelpPath"
                target="_blank"
                data-testid="vat-help-link"
                >{{ content }}</promo-page-link
              >
            </template>
          </gl-sprintf>
        </div>
        <div data-testid="vat">{{ taxAmount }}</div>
      </div>
    </div>
    <div class="gl-flex gl-justify-between gl-text-lg gl-font-bold">
      <div>{{ $options.i18n.total }}</div>
      <div data-testid="total-amount">
        {{ renderedAmount }}
      </div>
    </div>
  </div>
</template>
